package test;

import org.junit.Test;

import org.jgroups.JChannel;
import org.jgroups.Message;
import org.jgroups.ReceiverAdapter;
import org.jgroups.View;
import org.junit.Assert;
import org.junit.BeforeClass;

public class JGroupTest {

    @BeforeClass
    public static void init() {
        System.setProperty("java.net.preferIPv4Stack", "true");
    }
    private int received;

    @Test
    public void testJGROUP() throws Throwable {

        JChannel channelA = new JChannel("test-transport_1.xml");
        JChannel channelB = new JChannel("test-transport_1.xml");

        channelA.setReceiver(new ReceiverAdapter() {

            @Override
            public void receive(Message msg) {
                System.out.println("A Received " + msg.getSrc() + ": " + msg.getObject());
            }

            @Override
            public void viewAccepted(View new_view) {
                System.out.println("** view: " + new_view);
            }
        });


        channelB.setReceiver(new ReceiverAdapter() {

            @Override
            public void receive(Message msg) {
                System.out.println("B Received " + msg.getSrc() + ": " + msg.getObject());
                received++;
            }

            @Override
            public void viewAccepted(View new_view) {
                System.out.println("** view: " + new_view);
            }
        });

        channelA.connect("TEST");

        channelB.connect("TEST");

        for (int i = 0; i < 2; i++) {
            Thread.sleep(100);
            channelA.send(new Message(null, null, "Hello " + i));
        }
        Thread.sleep(1000);

        channelA.close();
        channelB.close();
        Assert.assertEquals(2, received);
    }
}
